{ pkgs
, nixpkgs
, unstablePkgs
, home-manager
, system
, mkHomeRole
, mkSysRole
, mkUser
, ...
}:

{
  mkHost = { name, users, roles ? [ ], imports ? [ ] }:
    let
      users_mod = (map
        (u:
          mkUser {
            name = u.user;
            roles = u.roles;
          })
        users);
      roles_mod = (map (r: mkSysRole r) roles);
      add_imports = imports;
    in
    nixpkgs.lib.nixosSystem {
      inherit system pkgs;

      modules = [
        {
          imports = users_mod ++ roles_mod ++ add_imports ++ [
            (mkSysRole "common")
            (mkSysRole "acme")
          ];

          home-manager = {
            users.root.imports = [ (mkHomeRole "common") ];
            extraSpecialArgs.unstablePkgs = unstablePkgs;
            useGlobalPkgs = true;
          };

          system.stateVersion = "23.05";
        }

        home-manager.nixosModules.home-manager
        ../hosts/${name}/default.nix
      ];
    };
}
